<template>
  <div class="feedbackAdd">
    <header
      ref="feedbacks"
      class="feedbackAdd-header">
      <h2 class="heading _h2">
        Отзывы&nbsp;
        <span class="feedbacks-count">{{ countFeedbacks }}</span>
      </h2>
      <div class="feedbackAdd-actions">
        <AppPopover
          v-if="!authUser"
          :options="popoverOptions"
          @click.native="$ym('seller_add_review')">
          <template slot="tooltip-content">
            <div class="tooltip-text">Доступно только авторизованным</div>
            <AppButton
              v-if="!$slots['entry-item'] || authUser"
              :classes="['userActionsTrigger', 'buttonOutline']"
              v-close-popover
              @click.native="onLogin(); $ym('seller_review_login')">
              <span
                slot="button-item"
                class="button-item">
                <span class="user-text">
                  {{ (authUser && authUser.username) || 'Войти или зарегистрироваться' }}
                </span>
              </span>
            </AppButton>
          </template>
          <template
            slot="tooltip-content"
            v-if="authUser && !authUser.userProfile">
            <span>Необходимо заполнить профиль</span>
          </template>
          <template slot="tooltip-trigger">
            <slot name="entry-item"/>
            <AppButton @click.native="onShowFeedback">
              <span
                slot="button-item"
                class="button-item">
                Добавить отзыв
              </span>
            </AppButton>
          </template>
        </AppPopover>
        <AppButton
          @click.native="onShowFeedback"
          v-if="authUser">
          <span
            slot="button-item"
            class="button-item">
            Добавить отзыв
          </span>
        </AppButton>
      </div>
    </header>
    <div v-show="isSuccess">
      <img
        svg-inline
        src="~/assets/svg/redesign/ok-big.svg">
      <div class="heading _h2">Ваш отзыв отправлен на модерацию. После проверки он будет размещён на сайте.</div>
    </div>
    <div
      class="feedbackAdd-content __box-gray"
      v-if="!isSuccess && hasFeedback && authUser">
      <div class="feedbackAdd-title">Новый отзыв о магазине {{ currentShop.shop_name }}</div>
      <div class="feedbackAdd-rating">
        <span>Ваша оценка:</span>
        <AppRating
          :read-only="false"
          @rating-selected="setRating"/>
      </div>
      <AppSelect
        v-model="currentShop"
        :options="shops"
        :classes="['_address', 'no-checkbox']"
        track-by="id"
        label="shop_name"
        @clear="onClear"/>
      <div class="input">
        <textarea
          v-model="feedbackText"
          placeholder="Текст отзыва"
          class="input-field _textarea"/>
      </div>
      <AppButton
        :classes="['buttonOutlineColor']"
        @click.native="onClickAddFeedback">
        <span
          slot="button-item"
          class="button-item">
          Отправить отзыв
        </span>
      </AppButton>
    </div>
  </div>
</template>

<script>
import AppPopover from '~/components/redesign/app-tooltip/app-popover';
import AppSelect from '~/components/redesign/app-select/app-select';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppRating from '~/components/redesign/app-rating';
import isMobileMixin from '~/assets/js/mixins/is-mobile';

// Enums
import RequestState from '~/assets/js/enums/request-state';

export default {
  name: 'FeedbackAdd',
  components: {
    AppButton,
    AppSelect,
    AppRating,
    AppPopover,
  },
  mixins: [isMobileMixin],
  props: {
    shops: {
      type: Array,
      default() { return []; },
    },
    authUser: {
      type: Object,
      default() { return {}; },
    },
    organizationUserId: {
      type: String,
      default: null,
    },
    countFeedbacks: {
      type: Number,
      default: 0,
    },
    feedbackFocus: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      currentShop: this.shops[0],
      feedbackText: '',
      isSuccess: false,
      hasFeedback: false,
      rating: null,
    };
  },
  computed: {
    popoverOptions() {
      return {
        trigger: 'click',
        enabled: Boolean(this.authUser),
        additionalClasses: ['tooltipFeedback', 'tooltipDark'],
      };
    },
  },
  mounted() {
    this.feedBackFocus();
  },
  methods: {
    onShowFeedback() {
      this.hasFeedback = true;
    },
    feedBackFocus() {
      try {
        if (this.feedbackFocus && !this.isMobile()) {
          window.scrollTo(0, this.$refs.feedbacks.offsetTop - 130);
        }

        if (this.feedbackFocus
          && this.authUser
          && !this.countFeedbacks) {
          this.onShowFeedback();
        }
      } catch (e) {
        console.log(e);
      }
    },
    async onClickAddFeedback() {
      if (!this.feedbackText || !this.rating || !this.organizationUserId) {
        return;
      }
      this.$ym('seller_send_review');

      try {
        const { type } = await this.$axios.$post('/_main/feedback/create', {
          data: {
            comment: this.feedbackText,
            rating: this.rating,
            recipientUserId: Number(this.organizationUserId),
          },
        });

        this.isSuccess = RequestState.SUCCESS === type;

        setTimeout(() => {
          this.isSuccess = false;
          this.resetFeedback();
        }, 5000);
      } catch (e) {
        this.resetFeedback();
        console.error(e);
      }
    },
    onClear() {
      this.currentShop = this.shops[0];
    },
    resetFeedback() {
      this.feedbackText = '';
      this.rating = 0;
    },
    setRating(rating) {
      this.rating = rating;
    },
    onLogin() {
      if (!this.auth) {
        this.$emit('login');
      }
    },
  },
};
</script>

<style lang="postcss">
  .feedbackAdd {
    &-header {
      display: flex;
      padding-bottom: 1rem;
    }
    &-actions {
      margin-left: auto;
    }
    &-content {
      display: block;
      margin-bottom: 3rem;
      margin-left: 3.5rem;
      padding: 1rem;
      width: 67%;
      min-width: 42rem;
      border: 1px solid var(--border-color-main);
    }
    &-title {
      padding-bottom: 1rem;
      font-size: 0.875rem;
      font-weight: var(--font-weight-medium);
    }
    &-rating {
      display: flex;
      padding-bottom: 0.5rem;
      font-size: 0.75rem;
      color: var(--color-main-lightest);
      .sellerRating {
        margin: 0 0.5rem;
      }
    }
    .multiselect._address {
      width: 20rem;
      .multiselect__select {
        display: flex !important;
      }
      .multiselect__clear{
        display: none !important;
      }
    }

    .input {
      padding: 1rem 0 2rem;
    }

    @media screen and (max-width: 980px) {
      &-header {
        align-items: center;
        padding: 0 1.25rem 1rem;
        border-bottom: 1px solid var(--border-color-main);
      }

      &-actions {
        padding: 0 1.25rem;
        .trigger {
          width: 100%;
        }
      }

      &-content {
        margin: 0 0 2rem;
        padding: 1.25rem;
        width: auto;
        min-width: auto;
        border: none;
        border-radius: 0;
      }

      &-title {
        font-size: 1rem;
      }
      &-rating {
        font-size: 0.875rem;
      }

      .multiselect._address {
        width: 100%;
      }

      .button {
        width: 100%;
      }
    }
  }

</style>
